glibmm: Glib::ObjectBase Class Reference

glibmm 2.29.13

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions

# Glib::ObjectBase Class Reference

Glib::ObjectBase is a common base class for Objects and Interfaces. More...

`#include <glibmm/objectbase.h>`

Inheritance diagram for Glib::ObjectBase:
[legend]

List of all members.

## Public Member Functions
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase&value)
| You probably want to use a specific property_*() accessor method instead.
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase&value) const
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType&value)
| You probably want to use a specific property_*() accessor method instead.
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType&value) const
| You probably want to use a specific property_*() accessor method instead.
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.
void | freeze_notify ()
| Increases the freeze count on object.
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify().
virtual void | reference () const
| Increment the reference count for this object.
virtual void | unreference () const
| Decrement the reference count for this object.
GObject* | gobj ()
| Provides access to the underlying C GObject.
const GObject* | gobj () const
| Provides access to the underlying C GObject.
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access.
## Protected Member Functions
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice.
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.
virtual | ~ObjectBase ()=0
void | initialize (GObject* castitem)

## Detailed Description

Glib::ObjectBase is a common base class for Objects and Interfaces.

This is used as virtual base class. This means the ObjectBase constructor runs before all others, either implicitly or explicitly. Each of the available constructors initializes custom_type_name_ in a different way.

## Constructor & Destructor Documentation

Glib::ObjectBase::ObjectBase | ( |  | ) | `[protected]`

This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor.

This is normal behaviour for C++ virtual inheritance.

The GType name will be gtkmm__anonymous_custom_type.

Glib::ObjectBase::ObjectBase | ( | const char * | custom_type_name | ) | `[explicit, protected]`

A derived constructor always overrides this choice.

The C++ language itself ensures that the constructor is only invoked once.

All classes generated by gtkmmproc use this constructor, with custom_type_name = 0, which essentially means it's not a custom type. This is used to optimize vfunc and signal handler callbacks -- since the C++ virtual methods are not overridden, invocation can be skipped.

The GType name will be custom_type_name.

Glib::ObjectBase::ObjectBase | ( | const std::type_info & | custom_type_info | ) | `[explicit, protected]`

This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually.

This feature is sometimes necessary, e.g. to implement a custom Gtk::CellRenderer. The neat trick with the virtual base class ctor makes it possible to reuse the same direct base class' constructor as with non-custom types.

The GType name will be custom_type_info.name().

virtual Glib::ObjectBase::~ObjectBase | ( |  | ) | `[protected, pure virtual]`

## Member Function Documentation

void Glib::ObjectBase::connect_property_changed | ( | const Glib::ustring& | property_name,
|  | const sigc::slot< void > & | slot
| ) |  |

You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.

See also connect_property_changed_with_return().

sigc::connection Glib::ObjectBase::connect_property_changed_with_return | ( | const Glib::ustring& | property_name,
|  | const sigc::slot< void > & | slot
| ) |  |

You can use the signal_changed() signal of the property proxy instead, but this is necessary when using the reduced API.

This method was added because connect_property_changed() does not return a sigc::connection, and we could not break the ABI by changing that function.

void Glib::ObjectBase::freeze_notify | ( |  | ) |

Increases the freeze count on object.

If the freeze count is non-zero, the emission of "notify" signals on object is stopped. The signals are queued until the freeze count is decreased to zero.

This is necessary for accessors that modify multiple properties to prevent premature notification while the object is still being modified.

template <class PropertyType >

void Glib::ObjectBase::get_property | ( | const Glib::ustring& | property_name,
|  | PropertyType & | value
| ) |  | const

You probably want to use a specific property_*() accessor method instead.

void Glib::ObjectBase::get_property_value | ( | const Glib::ustring& | property_name,
|  | Glib::ValueBase& | value
| ) |  | const

You probably want to use a specific property_*() accessor method instead.

const GObject* Glib::ObjectBase::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GObject.

Reimplemented in Glib::Interface, Gio::ActionGroup, Gio::AppLaunchContext, Gio::AppInfo, Gio::Application, Gio::ApplicationCommandLine, Gio::AsyncInitable, Gio::AsyncResult, Gio::BufferedInputStream, Gio::BufferedOutputStream, Gio::Cancellable, Gio::Credentials, Gio::DataInputStream, Gio::DataOutputStream, Gio::DBus::AuthObserver, Gio::DBus::Connection, Gio::DBus::Message, Gio::DBus::MethodInvocation, Gio::DBus::Proxy, Gio::DBus::Server, Gio::Drive, Gio::Emblem, Gio::EmblemedIcon, Gio::File, Gio::FileEnumerator, Gio::FileIcon, Gio::FileInfo, Gio::FileInputStream, Gio::FileIOStream, Gio::FileMonitor, Gio::FilenameCompleter, Gio::FileOutputStream, Gio::FilterInputStream, Gio::FilterOutputStream, Gio::Icon, Gio::InetAddress, Gio::InetSocketAddress, Gio::Initable, Gio::InputStream, Gio::IOStream, Gio::LoadableIcon, Gio::MemoryInputStream, Gio::MemoryOutputStream, Gio::Mount, Gio::MountOperation, Gio::NetworkAddress, Gio::NetworkService, Gio::OutputStream, Gio::Proxy, Gio::ProxyAddress, Gio::ProxyResolver, Gio::Resolver, Gio::Seekable, Gio::Settings, Gio::Socket, Gio::SocketAddress, Gio::SocketAddressEnumerator, Gio::SocketClient, Gio::SocketConnectable, Gio::SocketConnection, Gio::SocketControlMessage, Gio::SocketListener, Gio::SocketService, Gio::TcpConnection, Gio::ThreadedSocketService, Gio::ThemedIcon, Gio::Volume, Gio::VolumeMonitor, Gio::DesktopAppInfo, Gio::UnixConnection, Gio::UnixCredentialsMessage, Gio::UnixFDList, Gio::UnixFDMessage, Gio::UnixInputStream, Gio::UnixOutputStream, and Gio::UnixSocketAddress.

GObject* Glib::ObjectBase::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GObject.

Reimplemented in Glib::Interface, Gio::ActionGroup, Gio::AppLaunchContext, Gio::AppInfo, Gio::Application, Gio::ApplicationCommandLine, Gio::AsyncInitable, Gio::AsyncResult, Gio::BufferedInputStream, Gio::BufferedOutputStream, Gio::Cancellable, Gio::Credentials, Gio::DataInputStream, Gio::DataOutputStream, Gio::DBus::AuthObserver, Gio::DBus::Connection, Gio::DBus::Message, Gio::DBus::MethodInvocation, Gio::DBus::Proxy, Gio::DBus::Server, Gio::Drive, Gio::Emblem, Gio::EmblemedIcon, Gio::File, Gio::FileEnumerator, Gio::FileIcon, Gio::FileInfo, Gio::FileInputStream, Gio::FileIOStream, Gio::FileMonitor, Gio::FilenameCompleter, Gio::FileOutputStream, Gio::FilterInputStream, Gio::FilterOutputStream, Gio::Icon, Gio::InetAddress, Gio::InetSocketAddress, Gio::Initable, Gio::InputStream, Gio::IOStream, Gio::LoadableIcon, Gio::MemoryInputStream, Gio::MemoryOutputStream, Gio::Mount, Gio::MountOperation, Gio::NetworkAddress, Gio::NetworkService, Gio::OutputStream, Gio::Proxy, Gio::ProxyAddress, Gio::ProxyResolver, Gio::Resolver, Gio::Seekable, Gio::Settings, Gio::Socket, Gio::SocketAddress, Gio::SocketAddressEnumerator, Gio::SocketClient, Gio::SocketConnectable, Gio::SocketConnection, Gio::SocketControlMessage, Gio::SocketListener, Gio::SocketService, Gio::TcpConnection, Gio::ThreadedSocketService, Gio::ThemedIcon, Gio::Volume, Gio::VolumeMonitor, Gio::DesktopAppInfo, Gio::UnixConnection, Gio::UnixCredentialsMessage, Gio::UnixFDList, Gio::UnixFDMessage, Gio::UnixInputStream, Gio::UnixOutputStream, and Gio::UnixSocketAddress.

GObject* Glib::ObjectBase::gobj_copy | ( |  | ) | const

Give a ref-ed copy to someone. Use for direct struct access.

void Glib::ObjectBase::initialize | ( | GObject * | castitem | ) | `[protected]`

virtual void Glib::ObjectBase::reference | ( |  | ) | const`[virtual]`

Increment the reference count for this object.

You should never need to do this manually - use the object via a RefPtr instead.

template <class PropertyType >

void Glib::ObjectBase::set_property | ( | const Glib::ustring& | property_name,
|  | const PropertyType & | value
| ) |  |

You probably want to use a specific property_*() accessor method instead.

void Glib::ObjectBase::set_property_value | ( | const Glib::ustring& | property_name,
|  | const Glib::ValueBase& | value
| ) |  |

You probably want to use a specific property_*() accessor method instead.

void Glib::ObjectBase::thaw_notify | ( |  | ) |

Reverts the effect of a previous call to freeze_notify().

The freeze count is decreased on object and when it reaches zero, all queued "notify" signals are emitted.

It is an error to call this function when the freeze count is zero.

virtual void Glib::ObjectBase::unreference | ( |  | ) | const`[virtual]`

Decrement the reference count for this object.

You should never need to do this manually - use the object via a RefPtr instead.